<?php

  if (isset($_GET['debug'])) error_reporting(E_ALL);
  else error_reporting(0);




  # define ROOT 
  if (!defined('MN_ROOT')) define('MN_ROOT', str_replace('\\', '/', dirname(__FILE__) . '/'));





  if (is_dir(MN_ROOT . 'data/posts/') && file_exists(MN_ROOT . 'data/databases/config.php')) {

    # everything looks good, let's include some config files, functions, lang file and definitions
    include_once MN_ROOT . 'stuff/inc/mn-definitions.php';
    @include_once MN_ROOT . 'data/databases/config.php';
    include_once MN_ROOT . 'stuff/inc/mn-functions.php';
    $lng = (empty($mn_lang)) ? select_lang() : $mn_lang;
    include_once MN_ROOT . 'stuff/lang/lang_' . $lng . '.php';

    
    if (file_exists(MN_ROOT . $file['banned_ips'])) include_once MN_ROOT . $file['banned_ips'];
    else $banned_ips = array();



    # create url, where we want to show posts, page, ...
    if (!empty($mn_url)) $mn_url = $mn_url;
    elseif (empty($conf['web_url'])) $mn_url = $_SERVER['REQUEST_URI'];
    else $mn_url = $conf['web_url'];

    $mn_url = generate_url($mn_url);



    # check settings, choose best option
    $mn_count = (isset($mn_count) && is_numeric($mn_count)) ? (int)$mn_count : $conf['web_posts_count'];
    $mn_page = (isset($_GET['mn_page']) && !empty($_GET['mn_page'])) ? $_GET['mn_page'] : @$mn_page;
    $mn_pagination = (isset($mn_pagination)) ? $mn_pagination : $conf['web_pagination'];
    $mn_cat = (isset($mn_cat) && !empty($mn_cat)) ? $mn_cat : @$_GET['mn_cat'];
    $mn_cat = str_replace(' ', '', $mn_cat);
    $mn_cats = explode(',', $mn_cat);
    
    $mn_users = load_basic_data('users');
    $mn_categories = load_basic_data('categories');
    $mn_tags = load_basic_data('tags');



    # we can specify RSS action directly by setting mn-show.php?mode=rss
    if (isset($_GET['mode']) && $_GET['mode'] == 'rss') {$mn_mode = 'rss';}
    # check page number
    if (!isset($_GET['mn_p']) || !is_numeric($_GET['mn_p']) || $_GET['mn_p'] <= 0) $_GET['mn_p'] = 1;
    




    # Categories menu for posts
    if (isset($mn_mode) && $mn_mode == 'menu') {
      if (file_exists(MN_ROOT . $file['categories'])) {
        $cats = load_basic_data('categories');
        
        echo "\n\n\t\t<ul class=\"mn-menu\" id=\"mn-cat-menu\">\n";
        foreach ($cats as $cat_id => $cat_name) {
          $active_cat = (isset($_GET['mn_cat']) && $_GET['mn_cat'] == $cat_id) ? ' class="active"' : '';
          echo "\t\t\t<li><a href=\"" . $mn_url . "mn_cat=" . $cat_id . "\"" . $active_cat . ">" . encoding($cat_name) . "</a></li>\n";
        }
        echo "\t\t</ul>\n\n";
      }
      else echo encoding($lang['web_msg_no_cats_file']);
    }





    elseif (isset($mn_mode) && $mn_mode == 'pagemenu') {
    
      if (is_dir(MN_ROOT . $dir['pages'])) {
        $p_dir = dir(MN_ROOT . $dir['pages']);
        $pages = array(); $pages_order = array();

        while ($page_file = $p_dir->read()) {
          if (!is_file(MN_ROOT . $dir['pages'] . $page_file)) continue;
          else {
            $page_var = get_page_data($page_file, false);

            if ($page_var['visible'] == '1') {
              $pages[$page_var['id']] = $page_var['title'];
              $pages_order[$page_var['id']] = $page_var['order'];
            }
            else continue;
          }
        }
      }
      
      
      if (!empty($pages)) {
        asort($pages_order);

        echo "\n\n\t\t<ul class=\"mn-menu\" id=\"mn-page-menu\">\n";
        foreach ($pages_order as $page_id => $page_order) {
          $active_page = (isset($_GET['mn_page']) && $_GET['mn_page'] == $page_id) ? ' class="active"' : '';
          echo "\t\t\t<li><a href=\"" . $mn_url . "mn_page=" . $page_id . "\"" . $active_page . ">" . encoding($pages[$page_id]) . "</a></li>\n";
        }
        echo "\t\t</ul>\n\n";
      }

      else echo encoding($lang['web_msg_no_pages']);
    }





    # search form
    elseif (isset($mn_mode) && $mn_mode == 'search') {
      echo '<form action="' . $mn_url . '" method="get" class="mn-search-form"><input type="text" name="mn_q" value="" /> <input type="submit" class="submit" value="' . $lang['web_search'] . '" /></form>';
    }





    # advanced search form
    elseif (isset($mn_mode) && $mn_mode == 'advanced-search') {
      $timestamps = get_unique_timestamps();
      
      echo '<form action="' . $mn_url . '" method="get" class="mn-search-form"><fieldset>';

      echo '<select name="mn_cat" id="mn_cat"><option value="" class="description">--- ' . encoding($lang['posts_all_categories']) . ' ---</option>';
      foreach ($mn_categories as $cat_id => $cat_name) {echo '<option value="' . $cat_id . '">' . encoding($cat_name) . '</option>';}
      echo '</select> ';

      $posts_counts = get_posts_count('users');
      echo '<select name="mn_a" id="mn_a"><option value="" class="description">--- ' . encoding($lang['posts_all_users']) . ' ---</option>';
      foreach ($mn_users as $user_id => $user_name) {
        if (empty($posts_counts[$user_id])) continue;
        else echo '<option value="' . $user_id . '">' . $user_name . '</option>';
      }
      echo '</select> ';

      echo '<select name="mn_archive" id="mn_archive"><option value="" class="description">--- ' . encoding($lang['posts_all_dates']) . ' ---</option>';
      foreach ($timestamps as $key => $value) {echo '<option value="' . $value . '">' . encoding($lang['month'][date('n', $key)]) . ' ' . date('Y', $key) . '</option>';}
      echo '</select> ';

      echo '<input type="text" name="mn_q" value="" />
      <input type="submit" class="submit" value="' . encoding($lang['web_search']) . '" />
      </fieldset></form>';
    }





    # posts archive by months
    elseif (isset($mn_mode) && $mn_mode == 'archive') {
    
      $timestamps = get_unique_timestamps();
      
      echo '<ul class="mn-archive">';
      foreach ($timestamps as $key => $value) {
        echo '<li><a href="' . $mn_url . 'mn_archive=' . $value . '">' . encoding($lang['month'][date('n', $key)]) . ' ' . date('Y', $key) . '</a></li>';
      }
      echo '</ul>';
      
    }





    elseif (isset($mn_mode) && $mn_mode == 'include') {
    
      function get_title() {
        global $dir, $lang, $mn_categories;
        if (isset($_GET['mn_post']) && file_exists(MN_ROOT . $dir['posts'] . 'post_' . $_GET['mn_post'] . '.php')) {
          $p = get_post_data($_GET['mn_post']);
          return encoding($p['title']);
        }
        elseif (isset($_GET['mn_page']) && file_exists(MN_ROOT . $dir['pages'] . 'page_' . $_GET['mn_page'] . '.php')) {
          $p = get_page_data($_GET['mn_page']);
          return encoding($p['title']);
        }
        elseif (isset($_GET['mn_cat'])) {
          return encoding($lang['cats_category'] . ': ' . $mn_categories[$_GET['mn_cat']]);
        }
        else return encoding($lang['posts_posts']);
        
      }
      
    }





    # check search query for dangerous characters
    elseif (!empty($_GET['mn_q']) && (eregi('[!?\'$&/()=%*:;,\"#~|_+{}<>]', $_GET['mn_q']))) {
      echo encoding($lang['web_msg_search_forbidden']);
    }





    # show page
    elseif (isset($mn_page) && !empty($mn_page) && file_exists(MN_ROOT . $dir['pages'] . 'page_' . $mn_page . '.php')) {

      $page = get_page_data($mn_page);
      
      if (isset($page['pass']) && !empty($page['pass'])) {

        if ((isset($_GET['mn_key']) && $_GET['mn_key'] == substr(md5(substr($page['pass'], 1, 22) . $page['id'] . date('d.m.Y')), 6, 9)) || (isset($_POST['mn_pagepass']) && $page['pass'] == sha1($_POST['mn_pagepass']))) {
          $page_tmpl = (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_11.html')) ? $mn_tmpl : DEFAULT_TMPL;
          $page_result = page_tmpl($mn_page, $page_tmpl . '_11', $mn_url);

          echo encoding($page_result);
        }
        
        else {
          $page_result = '<p>' . $lang['web_page_password'] . ':</p>';
          $page_result .= '<form action="' . $mn_url . 'mn_page=' . $page['id'] . '" method="post"><input type="password" name="mn_pagepass" /> <input type="submit" value="vstúpiť" /></form>';
          echo encoding($page_result);
        }
        
      }
      
      
      else {
        $page_tmpl = (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_11.html')) ? $mn_tmpl : DEFAULT_TMPL;
        $page_result = page_tmpl($mn_page, $page_tmpl . '_11', $mn_url);

        echo encoding($page_result);
      }
      
    }





    # user profile
    elseif (isset($_GET['mn_user']) && !empty($_GET['mn_user']) && !empty($mn_users[$_GET['mn_user']])) {
    
      $user_tmpl = (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_13.html')) ? $mn_tmpl : DEFAULT_TMPL;
      $user_result = user_tmpl($_GET['mn_user'], $user_tmpl . '_13', $mn_url);

      echo encoding($user_result);
    
    }





    # show post
    elseif (isset($_GET['mn_post']) && !empty($_GET['mn_post']) && file_exists(MN_ROOT . $dir['posts'] . 'post_' . $_GET['mn_post'] . '.php')) {
      
      $p = get_post_data($_GET['mn_post']);

      if ($p['timestamp'] <= time() && $p['status'] <= '2') {
      
        $detail_tmpl = (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_10.html')) ? $mn_tmpl : DEFAULT_TMPL;
        $post_result = posts_tmpl($p['id'], $detail_tmpl . '_10', $mn_url);
        echo encoding($post_result);


        if ($conf['web_counter'] && empty($_COOKIE['mn_user_name'])) mn_put_contents(MN_ROOT . $dir['posts'] . 'post_' . $p['id'] . '.php', SAFETY_LINE . DELIMITER . "\n" . $p['id'] . DELIMITER . $p['timestamp'] . DELIMITER . $p['title'] . DELIMITER . $p['friendly_url'] . DELIMITER . $p['author'] . DELIMITER . $p['cat'] . DELIMITER . $p['status'] . DELIMITER . $p['comments'] . DELIMITER . ($p['views'] + 1) . DELIMITER . $p['tags'] . DELIMITER . '' . DELIMITER . '' . DELIMITER . '' . DELIMITER . '' . DELIMITER . "\n" . $p['short_story'] . DELIMITER . "\n" . $p['full_story']);



        if ($conf['comments']) {

          if ($p['comments'] != 2 && file_exists(MN_ROOT . $dir['comments'] . 'comments_' . $_GET['mn_post'] . '.php')) {

            $comment_tmpl = (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_12.html')) ? $mn_tmpl : DEFAULT_TMPL;

            $c_result = ''; $c_i = 1;
            $c_file = file(MN_ROOT . $dir['comments'] . 'comments_' . $_GET['mn_post'] . '.php');
            array_shift($c_file);

            if (!empty($c_file)) foreach ($c_file as $c_line) {$c_result .= comment_tmpl($c_line, $comment_tmpl . '_12', $mn_url, $c_i); $c_i++;}

            if (!empty($c_result)) echo '<div id="mn-comments">' . encoding($c_result) . '</div>';
            else echo '<p id="mn-comments" class="mn-comment-info">' . encoding($lang['web_msg_no_comments']) . '</p>';
          }
          elseif ($p['comments'] == 1) echo '<p id="mn-comments" class="mn-comment-info">' . encoding($lang['web_msg_no_comments']) . '</p>';


          if ($p['comments'] == 1 && in_array($_SERVER['REMOTE_ADDR'], $banned_ips)) {
            echo '<p class="mn-comment-info">' . encoding($lang['web_msg_banned_ip']) . '</p>';
          }
          elseif ($p['comments'] == 1) {
            $post_id = $p['id'];
            include MN_ROOT . 'stuff/inc/tmpl/comment-form.php';
          }
          else {
            $mn_comments_id = (empty($c_result)) ? ' id="mn-comments"' : '';
            echo '<p' . $mn_comments_id . ' class="mn-comment-info">' . encoding($lang['web_msg_comments_forbidden']) . '</p>';
          }

        }


      }
      else echo '<p class="mn-info">' .  $lang['web_msg_post_unavailable'] . '</p>';


    }





    # else... show posts :)
    elseif (file_exists(MN_ROOT . $file['posts'])) {
    
      # read posts file
      $p_file = file(MN_ROOT . $file['posts']);
      $posts = array();
      array_shift($p_file);
      $p_file = mn_natcasesort($p_file);
      $p_file = array_reverse($p_file, true);

      
      # put posts to arrays - one array for IDs, one for timestamps
      foreach ($p_file as $p_line) {
        $post = get_values('posts', $p_line, false);


        # we want only actuall and approved posts
        if ($post['timestamp'] > time()) continue;
        elseif (!isset($_GET['mn_a']) && $post['status'] != '1') continue;
        elseif (isset($_GET['mn_a']) && $post['status'] > '2') continue;
        else {
          # check other settings
          if (!empty($mn_cat) && (!in_array($post['cat'], $mn_cats))) continue;
          if (isset($_GET['mn_archive']) && !empty($_GET['mn_archive']) && ($_GET['mn_archive'] != date('Y-m', $post['timestamp']))) continue;
          if (isset($_GET['mn_a']) && !empty($_GET['mn_a']) && ($_GET['mn_a'] != $post['author'])) continue;
          if (isset($_GET['mn_tag']) && !empty($_GET['mn_tag'])) {
            $post['tags_array'] = (!empty($post['tags'])) ? explode(',', trim($post['tags'])) : array();
            if (!in_array($_GET['mn_tag'], $post['tags_array'])) continue;
          }
          if (isset($_GET['mn_q']) && !empty($_GET['mn_q']) && (strlen($_GET['mn_q']) > 2)) {
            $post_content = file_get_contents(MN_ROOT . $dir['posts'] . 'post_' . $post['post_id'] . '.php');
            if (stripos($post_content, $_GET['mn_q']) === false) continue;
          }
          
          $posts[] = $post['post_id'];
        }
      }
      
      
      
      # OMG we actually do have some posts! Let's show them
      if (!empty($posts)) {
      
        $posts_count = count($posts);
        
        
        # if we want to see pagination, we need some hard work
        if ($mn_pagination) {
          
          # set pagination link path
          $mn_pagination_url = $mn_url;
          if (isset($_GET['mn_a'])) $mn_pagination_url = $mn_pagination_url . 'mn_a=' . $_GET['mn_a'] . '&amp;';
          if (isset($_GET['mn_archive'])) $mn_pagination_url = $mn_pagination_url . 'mn_archive=' . $_GET['mn_archive'] . '&amp;';
          if (isset($_GET['mn_cat'])) $mn_pagination_url = $mn_pagination_url . 'mn_cat=' . $_GET['mn_cat'] . '&amp;';
          if (isset($_GET['mn_q'])) $mn_pagination_url = $mn_pagination_url . 'mn_q=' . $_GET['mn_q'] . '&amp;';
    
    
          require_once MN_ROOT . 'stuff/inc/paginator.class.php';

          $pages = new Paginator;
          $pages->items_total = $posts_count;
          $pages->items_per_page = $mn_count;
          $pages->current_page = $_GET['mn_p'];
          $pages->show_path = $mn_pagination_url;
          $pages->paginate();
          $pages_tmpl_content = $pages->display_pages();
          
          $j = ( ($_GET['mn_p'] - 1) * $mn_count );
          $max = ( ($posts_count - $j) > $mn_count ) ? ( $j + $mn_count ) : $posts_count;
          
          if ($j == 0 && $max == $posts_count) $mn_pagination = false;

        }
        else {
          $j = ( ($_GET['mn_p'] - 1) * $mn_count );
          $max = ( ($posts_count - $j) > $mn_count ) ? ( $j + $mn_count ) : $posts_count;
        }
        
        
        
        # choose template
        # scary piece of code, I know...
        if (!empty($mn_mode) && $mn_mode == 'rss') $tmpl_type = 14;
        elseif (isset($mn_cat) && !empty($mn_cat)) $tmpl_type = 2;
        elseif (isset($_GET['mn_archive']) && !empty($_GET['mn_archive'])) $tmpl_type = 3;
        elseif (isset($_GET['mn_q']) && !empty($_GET['mn_q'])) $tmpl_type = 4;
        elseif (isset($_GET['mn_a']) && !empty($_GET['mn_a'])) $tmpl_type = 5;
        else $tmpl_type = 1;
        
        if (isset($mn_tmpl) && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_' . $tmpl_type . '.html')) $post_tmpl = $mn_tmpl . '_' . $tmpl_type;
        elseif (isset($mn_tmpl) && !file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_' . $tmpl_type . '.html') && file_exists(MN_ROOT . $dir['templates'] . $mn_tmpl . '_1.html')) $post_tmpl = $mn_tmpl . '_1';
        elseif (file_exists(MN_ROOT . $dir['templates'] . DEFAULT_TMPL . '_' . $tmpl_type . '.html')) $post_tmpl = DEFAULT_TMPL . '_' . $tmpl_type;
        else $post_tmpl = DEFAULT_TMPL . '_1';

        
        $show_path = $mn_url;
        $posts_result = '';
        for ($i = $j; $i <= $max-1; $i++) {
          $posts_result .= posts_tmpl($posts[$i], $post_tmpl, $mn_url);
        }
        


        if (isset($mn_mode) && $mn_mode == 'rss') {
          $domain = explode('/', $conf['admin_url']);
          header('Content-Type: text/xml');
          echo "<?xml version=\"1.0\" encoding=\"utf-8\"?" . ">\n<rss version=\"2.0\">\n<channel>\n\t<title>" . $conf['web_title'] . "</title>\n\t<link>http://" . $domain[2] . "/</link>\n\t<description>" . $lang['web_rss_description'] . " " . $domain[2] . ".</description>\n\t<language>" . $conf['lang'] . "</language>\n\n" . $posts_result . "\n</channel>\n</rss>";
        }
        
        else {
          if (isset($_GET['mn_q']) && (strlen($_GET['mn_q']) > 2)) echo '<p class="mn-info">' . str_replace('%s%', '"<strong>' . htmlspecialchars($_GET['mn_q'], ENT_QUOTES) . '</strong>"', encoding($lang['web_msg_search_found'])) . '</p>';
          elseif (isset($_GET['mn_cat']) && !empty($mn_categories[$_GET['mn_cat']])) echo '<p class="mn-info">' . str_replace('%c%', '"<strong>' . $mn_categories[$_GET['mn_cat']] . '</strong>"', encoding($lang['web_msg_cat_posts'])) . '</p>';
          elseif (isset($_GET['mn_tag']) && !empty($mn_tags[$_GET['mn_tag']])) echo '<p class="mn-info">' . str_replace('%t%', '"<strong>' . $mn_tags[$_GET['mn_tag']] . '</strong>"', encoding($lang['web_msg_tag_posts'])) . '</p>';

          echo encoding($posts_result);

          if ($mn_pagination) echo '<p class="mn-pagination">' . encoding($pages_tmpl_content) . '</p>';
          if ($conf['web_powered_by']) echo '<p style="text-align: center; margin: 5px 0; font-size: 0.9em;">Powered by <a href="http://mnewscms.com/">MNews</a>!</p>';
        }
        
        
        
      }




      else {
        echo '<p class="mn-info">';
        if (isset($_GET['mn_q'])) echo '<p class="mn-info">' . str_replace('%s%', '"<strong>' . htmlspecialchars($_GET['mn_q']) . '</strong>"', encoding($lang['web_msg_search_no_posts'])) . '</p>';
        elseif (isset($mn_cat) && !empty($mn_cat)) echo encoding($lang['web_msg_cat_no_posts']);
        else echo encoding($lang['web_msg_no_posts']);
        echo '</p>';
      }

    }
    
    
    
    
    
    else {
      echo '<p class="mn-info">' . encoding($lang['web_msg_no_posts']) . '</p>';
    }







  }
  
  
  
  else {
    if (!isset($mn_mode)) echo '<p class="mn-info">We\'re sorry, but our system is temporarily unavailable(probably due to scheduled maintenance or upgrade)!<br /><em>If the problem persists, please contact the website administrator.</em></p>';
    else echo $mn_mode . 'temporarily unavailable.';
  }



  unset($active_cat, $active_page, $c_file, $c_result, $cat_id, $cat_name, $comment_tmpl, $detail_tmpl, $key, $mn_cat, $mn_count, $mn_mode, $mn_pagination, $mn_tmpl, $mn_url, $p, $p_line, $p_file, $page_id, $page_order, $page_result, $page_tmpl, $page_var, $page_file, $pages, $pages_order, $post, $post_tmpl, $posts, $posts_result, $timestamps, $user_id, $user_name, $value);
?>